'From Squeak 2.0 of May 22, 1998 on 17 September 1998 at 2:29:12 am'!


!Float methodsFor: 'special functions' stamp: 'A.T. 8/30/1998 19:09'!
Q
   | h t v sum |

	self < 0
		ifTrue: [ ^ 1 - ( (self negated) Q) ].

	self = 0
		ifTrue: [ ^ 0.5 ].

    h _  1 / ( (2*Float pi) sqrt ) * ( (  ( self*self negated) / 2) exp ).
    t _ 1 / (0.2316419 * self + 1).

     v _ #( 0.319381530 -0.356563782 1.781477937 -1.821255978 1.330274429 ).

     sum _ 0.0.

     1 to: v size do: [ :i | sum _ sum + ( (v at:i) * t). t _ (t * t) ].
     sum _ sum * h.

	^ sum.




    

		


! !

!Float methodsFor: 'special functions'!
beta: aFloat
	^  (  (self gammaLn)  + (aFloat gammaLn) - ((self-aFloat) gammaLn)  )  exp! !

!Float methodsFor: 'special functions' stamp: 'A.T. 8/24/1998 22:31'!
betaI: aFloat
	^  self error: 'not yet implemented'! !

!Float methodsFor: 'special functions' stamp: 'A.T. 8/29/1998 17:15'!
chiSquared: nu

	self <= 0
		ifTrue: [ ^ 0.0 ].

	^ (self/2) gammaP: (nu/2)! !

!Float methodsFor: 'special functions' stamp: 'A.T. 8/24/1998 22:08'!
erffc
	| x |

	x _ self * self.

	self < 0.0
	ifTrue: [ ^ (1.0 + (x gammaP: 0.5) ) ]
     ifFalse: [ ^ (x gammaQ: 0.5) ]! !

!Float methodsFor: 'special functions' stamp: 'A.T. 8/24/1998 18:15'!
errf

     |  x  |

     x _ self * self.

	self < 0.0
  	ifTrue: [ ^ ( x gammaP: 0.5 ) negated ]
     ifFalse: [ ^ x gammaP: 0.5 ]
! !

!Float methodsFor: 'special functions' stamp: 'A.T. 8/30/1998 18:39'!
gamma
     ^ (2*(Float pi)) sqrt * ( (self negated) exp)  * (self raisedTo: ( self-0.5) )
	"^ ( self gammaLn) exp"! !

!Float methodsFor: 'special functions'!
gammaLn
	" Calculates ln( Gamma(x) )  using algorithm 6.1 from:
       Press et al. 'Numerical recipes in C', Cambridge University Press, 1992."

	| tmp ser y cof x  |

	y _ self+1.
	x _ self+1.

	tmp _ y + 5.5.
	tmp _ tmp - ( (y + 0.5) * (tmp ln) ).

	ser _ 1.000000000190015.

	cof _  #(  76.18009172947146  -86.50532032941677  24.01409824083091	-1.231739572450155 0.001208650973866179 -0.000005395239384953 ).

	1 to: 6 do:
	[  :i |
        y _ y + 1.
	   ser _ ser + ( (cof at: i) / y ).
	].
    ^ (tmp negated) + (( 2.5066282746310005 * ser / x ) ln )
! !

!Float methodsFor: 'special functions' stamp: 'A.T. 8/29/1998 17:20'!
gammaP: a

	 self < 0.0
				ifTrue: [ ^ self error: 'invalid argument'. ].
	a <= 0
                   ifTrue: [ ^ self error: 'invalid argument'. ].

	self < ( a + 1.0 )
			ifTrue: [  ^ (self gser: a) ]
			ifFalse: [ ^ (1 - (self gcf: a) ) ].

	
	! !

!Float methodsFor: 'special functions' stamp: 'A.T. 8/24/1998 23:59'!
gammaQ: a


      a <= 0
		ifTrue: [ ^ self error: 'invalid argument' ].

	 (self < 0.0) 
			ifTrue: [ ^ self error: 'invalid argument'. ].
    
	"self < ( a + 1.0 )
			ifTrue: [ self halt.  ^ ( 1.0 - (self gser: a)) ]
			ifFalse: [ ^ self gcf: a ]."

	
	^ self gcf: a! !

!Float methodsFor: 'special functions' stamp: 'A.T. 8/25/1998 00:07'!
gcf: a
     | gLn b c d h an del |


     gLn _  self gammaLn.
     b _  ( (self + 1.0) - a).
     c _  (1.0 / 1.0e-30). 
     d _ (1.0 /b).
     h _ d.

	1 to: 600 do:
	[ 	:i |
		an _ (i negated * ( i - a )).
		b _ (b + 2.0).
		d _ (an * d + b).
	
		d abs < 1.0e-30
				ifTrue: [ d _ 1.0e-30. ].

		c _ (b + (an/c)).
	
		c abs < 1.0e-30
				ifTrue: [ c _ 1.0e-30 ].

		d _ (1.0 / d).
		del _ (d * c).
		h _ (h * del).

         (del-1.0) abs < 3.0e-7
				ifTrue: [  ^ ( ( self negated + ( a * (self ln)  - gLn ) ) exp * h) ].
    ].

	^ ( ( self negated + ( a * (self ln)  - gLn ) ) exp * h)! !

!Float methodsFor: 'special functions' stamp: 'A.T. 8/29/1998 17:22'!
gser: a
	
 | gLn ap del sum |

 gLn _ (a gammaLn).

 "self halt."
 
 self < 0.0
	ifTrue: [ ^  self error: 'gser of a number less than zero'. ].

 self = 0.0
	ifTrue: [ ^ 0.0 ].

	ap _ a.
 
    del _ (1.0 / a).
    sum _ (1.0 / a).

    1 to: 100 do: [ :i | ap _ (ap + 1).
					del _ (del * self / ap).
					sum _ (sum + del).
					(del abs) < ((sum abs) * 3.0e-7 )
                              ifTrue: [ ^ sum * (    (   (self negated) + (a * (self ln) )  )  exp   )  ]. ].

						 "ifTrue: [  ^ ( sum * ( ( (self negated) + ( ( a * (self ln) ) - gLn ) ) exp ) ) ]. ]."

	^ self error: 'a too large, 100 too small to iterate in gser'! !
