Object subclass: #Function
	instanceVariableNames: 'name evaluator '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Function'!

!Function methodsFor: 'accessing-private' stamp: 'A.T. 8/25/1998 16:40'!
evaluator: anObject
	evaluator _ anObject! !


!Function methodsFor: 'accessing' stamp: 'len 6/26/1998 00:52'!
name
	^ name ifNil: [evaluator printString]! !

!Function methodsFor: 'accessing' stamp: 'len 6/26/1998 00:52'!
name: aString
	name _ aString! !

!Function methodsFor: 'accessing' stamp: 'len 6/26/1998 00:51'!
valueAt: anObject
	^ evaluator value: anObject! !


!Function methodsFor: 'printing' stamp: 'len 6/26/1998 00:53'!
printOn: aStream
	aStream nextPutAll: self name! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Function class
	instanceVariableNames: ''!

!Function class methodsFor: 'instance creation' stamp: 'len 6/26/1998 01:16'!
evaluator: anObject
	^ self new evaluator: anObject! !

!Function class methodsFor: 'instance creation' stamp: 'len 6/26/1998 01:16'!
newFrom: anObject
	^ self evaluator: anObject! !


!Function class methodsFor: 'examples' stamp: 'len 6/26/1998 01:19'!
constant: anObject
	^ self evaluator: [ :x | anObject]! !

!Function class methodsFor: 'examples' stamp: 'len 6/26/1998 01:18'!
cos
	^ self evaluator: #cos! !

!Function class methodsFor: 'examples' stamp: 'len 6/26/1998 01:15'!
id
	"Answer the identity function."
	^ self evaluator: #yourself! !

!Function class methodsFor: 'examples' stamp: 'len 6/26/1998 01:18'!
sin
	^ self evaluator: #sin! !

!Function class methodsFor: 'examples' stamp: 'len 6/26/1998 01:17'!
x
	"Answer the x projector function."
	^ self evaluator: #x! !

!Function class methodsFor: 'examples' stamp: 'len 6/26/1998 01:17'!
y
	"Answer the y projector function."
	^ self evaluator: #y! !


Function subclass: #TableFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Function'!

!TableFunction methodsFor: 'initialization' stamp: 'len 6/26/1998 00:54'!
initialize
	evaluator _ Dictionary new! !


!TableFunction methodsFor: 'accessing' stamp: 'len 6/26/1998 00:54'!
map: anObject to: anotherObject
	evaluator at: anObject put: anotherObject! !

!TableFunction methodsFor: 'accessing' stamp: 'len 6/26/1998 00:54'!
valueAt: anObject
	^ evaluator at: anObject! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

TableFunction class
	instanceVariableNames: ''!

!TableFunction class methodsFor: 'instance creation' stamp: 'len 6/26/1998 00:55'!
new
	^ super new initialize! !
