Stream subclass: #ProbDist
	instanceVariableNames: 'name '
	classVariableNames: 'LinearGenerator '
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!ProbDist methodsFor: 'accesing' stamp: 'A.T. 8/15/1998 21:14'!
atEnd
	^ false! !

!ProbDist methodsFor: 'accesing' stamp: 'ary + r++ 8/4/1998 23:28'!
name
	^ name! !

!ProbDist methodsFor: 'accesing' stamp: 'ary + r++ 8/4/1998 23:28'!
name: aString
	name _ aString! !


!ProbDist methodsFor: 'private' stamp: 'A.T. 8/10/1998 18:13'!
inverseDistribution: x
	self subclassResponsibility! !

!ProbDist methodsFor: 'private' stamp: 'A.T. 8/10/1998 18:32'!
random
	^ LinearGenerator next! !



!ProbDist methodsFor: 'sampling' stamp: 'A.T. 8/14/1998 22:05'!
sample: sampleSize

	| r |

	r _ Array new: sampleSize.

	1 to: sampleSize do: [ :i |  r at:i put: self next ].
	^ r



! !


!ProbDist methodsFor: 'probability functions' stamp: 'A.T. 8/10/1998 18:13'!
density: x
	self subclassResponsibility! !

!ProbDist methodsFor: 'probability functions' stamp: 'A.T. 8/13/1998 02:00'!
distribution: x
	self subclassResponsibility! !

!ProbDist methodsFor: 'probability functions' stamp: 'ary + r++ 8/4/1998 23:26'!
mean
	self subclassResponsibility! !

!ProbDist methodsFor: 'probability functions' stamp: 'A.T. 8/16/1998 18:14'!
next
	 ^ self inverseDistribution: self random! !

!ProbDist methodsFor: 'probability functions' stamp: 'A.T. 8/25/1998 00:34'!
sigma
	^ ( self var ) sqrt! !

!ProbDist methodsFor: 'probability functions' stamp: 'A.T. 8/14/1998 22:02'!
valueAt: nNumber
	^  self density: nNumber! !

!ProbDist methodsFor: 'probability functions' stamp: 'ary + r++ 8/4/1998 23:27'!
var
	self subclassResponsibility! !


!ProbDist methodsFor: 'initialization' stamp: 'A.T. 8/15/1998 21:09'!
initLinear
     LinearGenerator isNil
    		               ifTrue: [ LinearGenerator _ Random new ].! !


!ProbDist methodsFor: 'stream' stamp: 'A.T. 8/26/1998 11:49'!
contents
	self error: 'not applicable'! !

!ProbDist methodsFor: 'stream' stamp: 'A.T. 8/26/1998 11:49'!
do: aBlock
	self error: 'not applicable'! !

!ProbDist methodsFor: 'stream' stamp: 'A.T. 8/26/1998 11:52'!
next: aNumber put: anObject
	self error: 'not applicable'! !

!ProbDist methodsFor: 'stream' stamp: 'A.T. 8/26/1998 11:54'!
nextPut: anObject
	self error: 'not applicable'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ProbDist class
	instanceVariableNames: ''!

!ProbDist class methodsFor: 'instance creation' stamp: 'A.T. 8/15/1998 21:09'!
new
	^ super basicNew initLinear

	
   


	! !


ProbDist subclass: #ContinousDist
	instanceVariableNames: 'integrator '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!ContinousDist methodsFor: 'accesing' stamp: 'A.T. 9/17/1998 00:16'!
integrator: anIntegrator
	integrator _ anIntegrator! !


!ContinousDist methodsFor: 'initialization' stamp: 'A.T. 9/17/1998 01:52'!
initialize
	integrator _ TrapezoidalIntegralApproximator new.
    integrator steps: 500.! !


!ContinousDist methodsFor: 'private' stamp: 'A.T. 8/11/1998 00:35'!
random
	^ super random! !


!ContinousDist methodsFor: 'probability functions' stamp: 'ary + r++ 8/5/1998 02:12'!
density: nValue
	self subclassResponsibility! !

!ContinousDist methodsFor: 'probability functions' stamp: 'A.T. 9/17/1998 01:52'!
distribution: x
		"When not overriden, the integral of density(X) between -infinit and  x is returned.

		if x > mean : The integral between the mean and x is calculated ( I ), and  returns  1/2 + I
         if x < mean  : The integral between x and the mean is calculated ( I ), and returns 1 - (1/2+I)"

           x = self mean ifTrue: [ ^ 0.5 ].
           x = Infinity   ifTrue: [ ^ 1.0 ].
           x = (Infinity negative) ifTrue: [ ^ 0.0 ].

          integrator function: self.
           
               x > self mean
			ifTrue: 
              [
 				integrator left: 0.
				integrator right: x.
                   ^ (integrator approximation) + 0.5.
              ]
			ifFalse: 
              [
 				integrator left: x.
				integrator right: 0.
                   ^ 1-(integrator approximation)-0.5.
              ]
! !

!ContinousDist methodsFor: 'probability functions' stamp: 'A.T. 8/30/1998 18:28'!
inverseDistribution: delta
| a b  Zu d t |


 delta = 0 ifTrue: [ ^ Infinity negative ].
 delta = 1 ifTrue: [ ^ Infinity ].
 delta = 0.5 ifTrue: [ ^ self mean ].
 (delta <0 or: [delta>1] ) ifTrue: [ ^ self error: 'invalid parameter' ].  

 " check to see if a 20 var interval is always enough for any distribution. How can we lower it for each case ?"

 a _ self mean - ( 10 * (self var) ).
 b _ self mean + (10 * (self var)).

 d _ 1.0 - delta.

 Zu _ ( a + ( (b-a) /2 ) asFloat).

 t _ 1.0 - ( self distribution: Zu ).

 [ ( t - d ) abs < 1e-5 ] whileFalse:	
	[
		t > d
			ifTrue:   [ a _ Zu ]
			ifFalse:	 [ b _ Zu ].

		Zu _ ( a + ( (b-a)/2.0)  ) asFloat.
         t _ 1.0 - ( self distribution: Zu ).
    ].

   ^ Zu! !

!ContinousDist methodsFor: 'probability functions' stamp: 'A.T. 8/13/1998 03:12'!
mean
	^ self subclassResponsibility! !

!ContinousDist methodsFor: 'probability functions' stamp: 'A.T. 8/14/1998 22:03'!
next
	self subclassResponsibility! !

!ContinousDist methodsFor: 'probability functions' stamp: 'A.T. 8/13/1998 03:12'!
var
	"usually overriden, if not calculates vaqr by definition: by integration"
	self subclassResponsibility! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ContinousDist class
	instanceVariableNames: ''!

!ContinousDist class methodsFor: 'instance creation' stamp: 'A.T. 9/17/1998 00:16'!
new
	^ super new initialize! !


ProbDist subclass: #DiscreteDist
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!DiscreteDist methodsFor: 'private' stamp: 'A.T. 8/10/1998 18:31'!
random
	^ super random! !


!DiscreteDist methodsFor: 'probability functions'!
density: aNumber
	self subclassResponsibility! !

!DiscreteDist methodsFor: 'probability functions' stamp: 'A.T. 8/13/1998 03:11'!
distribution: aNumber

	^ self subclassResponsibility! !

!DiscreteDist methodsFor: 'probability functions' stamp: 'A.T. 8/13/1998 03:11'!
mean

	self subclassResponsibility! !

!DiscreteDist methodsFor: 'probability functions' stamp: 'A.T. 8/14/1998 22:04'!
next
	self subclassResponsibility! !

!DiscreteDist methodsFor: 'probability functions' stamp: 'A.T. 8/13/1998 03:03'!
var
  	^  self subclassResponsibility! !


DiscreteDist subclass: #Bernoulli
	instanceVariableNames: 'p '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!Bernoulli methodsFor: 'accesing' stamp: 'A.T. 8/10/1998 19:22'!
p
	^ p! !


!Bernoulli methodsFor: 'initialization' stamp: 'A.T. 8/16/1998 22:18'!
initialize: aNumber
	p _ aNumber.
	self name: 'Bernoulli(', p asString ,')'! !

!Bernoulli methodsFor: 'initialization' stamp: 'A.T. 8/15/1998 23:13'!
p: aNumber
	self initialize: aNumber! !


!Bernoulli methodsFor: 'probability functions' stamp: 'A.T. 8/10/1998 18:25'!
density: aNumber
	(aNumber == 0)
		ifTrue: [ ^ (1-p)   ]
		ifFalse: [^ p       ] ! !

!Bernoulli methodsFor: 'probability functions' stamp: 'A.T. 8/10/1998 18:26'!
distribution: aNumber
	(aNumber == 0)
		ifTrue: [  ^ (1-p)   ]
		ifFalse: [ ^1         ]  ! !

!Bernoulli methodsFor: 'probability functions'!
mean
	^ p! !

!Bernoulli methodsFor: 'probability functions' stamp: 'A.T. 8/21/1998 04:34'!
next
	| t |
	t _ self random.
	(  t <= p )
		ifTrue: [ ^ 1 ]
	    ifFalse: [ ^ 0 ] ! !

!Bernoulli methodsFor: 'probability functions'!
var
	^ p * (1 - p)! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Bernoulli class
	instanceVariableNames: ''!

!Bernoulli class methodsFor: 'instance creation' stamp: 'A.T. 8/12/1998 02:04'!
parameter: aNumber
	^ super new initialize: aNumber.
	! !


Bernoulli subclass: #Binomial
	instanceVariableNames: 'n '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!Binomial methodsFor: 'initialization' stamp: 'A.T. 8/16/1998 22:19'!
initialize: nEvents probability: nProb
	n _ nEvents.
	self p: nProb.
	self name: 'Binomial(', nEvents asString ,',',  nProb asString ,')'
! !


!Binomial methodsFor: 'probability functions' stamp: 'A.T. 8/11/1998 00:01'!
density: anInteger
     anInteger > n 
		ifTrue: [ ^ 0.0 ]
          ifFalse: [  ^ (n take: anInteger)  * 
                       ( (super mean) raisedTo: anInteger) * 
                       ( (1-super mean) raisedTo: ( (n-anInteger) asFloat)) ]
 ! !

!Binomial methodsFor: 'probability functions' stamp: 'A.T. 8/10/1998 19:20'!
distribution: anInteger
	^ 1 - ( (anInteger asFloat) betaI: ( self n - anInteger + 1) )
! !

!Binomial methodsFor: 'probability functions' stamp: 'A.T. 8/21/1998 04:36'!
mean
^ super mean * n! !

!Binomial methodsFor: 'probability functions' stamp: 'A.T. 8/14/1998 22:03'!
next
	| r |
	r _ 0.
	1 to: n do: [ :i | r _ r + super next ].
	^ r! !

!Binomial methodsFor: 'probability functions' stamp: 'A.T. 8/21/1998 04:38'!
var
^  super var * n! !


!Binomial methodsFor: 'accesing' stamp: 'A.T. 8/10/1998 19:17'!
n
	^ n! !

!Binomial methodsFor: 'accesing' stamp: 'A.T. 8/11/1998 00:09'!
p
	^ super p! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Binomial class
	instanceVariableNames: ''!

!Binomial class methodsFor: 'instance creation' stamp: 'A.T. 8/10/1998 23:52'!
events: nEvents probability: nProb
	^ self new initialize: nEvents probability: nProb! !


ContinousDist subclass: #Gamma
	instanceVariableNames: 'b c '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!Gamma methodsFor: 'initialization' stamp: 'A.T. 9/17/1998 00:18'!
initialize: x c: y
     super initialize.
	b _ x.
	c _ y.
	self name: 'Gamma(', x asString, ',', y asString, ')'

	! !


!Gamma methodsFor: 'accesing' stamp: 'A.T. 8/12/1998 01:27'!
b
	^ b! !

!Gamma methodsFor: 'accesing' stamp: 'A.T. 8/12/1998 01:27'!
c
	^ c! !


!Gamma methodsFor: 'probability functions' stamp: 'A.T. 8/25/1998 00:32'!
density: x
     x > 0
		ifTrue: [  ^ (c raisedTo:b) * (x raisedTo: (b-1))  *  ( (c * x negated) exp ) / (b gamma) ]
		ifFalse: [ ^ 0.0 ].
! !

!Gamma methodsFor: 'probability functions' stamp: 'A.T. 8/11/1998 00:50'!
mean
	^ b

! !

!Gamma methodsFor: 'probability functions' stamp: 'A.T. 8/15/1998 20:45'!
next
	"Algorithm taken from:
     Knuth, D., 'The Art of Computer Programming', Vol. II, Addison Wesley, 1992"

	|  Y X  t V |   
     b isInteger
	ifTrue: [ 	Y _ 1.0.
	 			1 to: b do: [ :i | Y _ Y * self random ].
			     ^ Y ln negated
			]
	ifFalse: [	

				V _ 1.0.
				t _ 0.0.

				[ V > t ] whileTrue:	
				          [
     				        X _ 0.0.
				            [X<=0] whileTrue:
						          [ Y _ (Float pi * self random) tan.
						            X _ (2*b-1) sqrt * Y + b - 1 
                                      ].
						  V _ self random.
						  t _ (1 + Y * Y) * ( (b-1) * (  (X/(b-1) ) ln - (( (2*b-1) sqrt) * Y) ) exp )
                             ].
						^ X
	           ]

! !

!Gamma methodsFor: 'probability functions' stamp: 'A.T. 8/11/1998 00:51'!
var
	^ b / ( c * c)

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Gamma class
	instanceVariableNames: ''!

!Gamma class methodsFor: 'instance creation' stamp: 'A.T. 8/12/1998 02:07'!
b: x c: y
	^ self new initialize:x c:y! !


Gamma subclass: #ChiSquared
	instanceVariableNames: 'nu '
	classVariableNames: 'Ttable '
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!ChiSquared methodsFor: 'initialization' stamp: 'A.T. 8/29/1998 17:17'!
initialize: x
	super initialize:(x/2) c:0.5.
     nu _ x.
	self name: 'ChiSquared(',  x  asString ,')'! !


!ChiSquared methodsFor: 'probability functions' stamp: 'A.T. 9/14/1998 02:40'!
distribution: x


"nu > 50 ifTrue: 
x <  (Ttable at:m at:1) ifTrue: [ ^ self error: 'not yet implemented' ].
x < (Ttable at:m at:2) ifTrue: [  ^0.9 ].
x < (Ttable at:m at:3) ifTrue: [  ^0.95 ].
x < (Ttable at:m at:4) ifTrue: [  ^0.975 ].
x < (Ttable at:m at:5) ifTrue: [  ^0.99 ].
^ 0.995."
	
^ (x asFloat) chiSquared: nu
! !

!ChiSquared methodsFor: 'probability functions' stamp: 'A.T. 8/30/1998 02:24'!
inverseDistribution: delta
| n z |

   nu > 50 ifTrue: 
		[ 
				n _ Normal standard.
		      	z  _ (n inverseDistribution: delta ).
				^ 0.5 * ( ( z + ( (2*nu-1) sqrt ) ) raisedTo: 2 ) 
		]

		ifFalse: [ ^ super inverseDistribution: delta ]

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ChiSquared class
	instanceVariableNames: ''!

!ChiSquared class methodsFor: 'initialize Array' stamp: 'A.T. 9/14/1998 02:38'!
initializeArray

     Ttable _ Array2D new.
	Ttable width:50 height:10 type:Array.
     Ttable atAllPut: 0.0.


    
     
! !


!ChiSquared class methodsFor: 'instance creation' stamp: 'A.T. 9/14/1998 02:37'!
nu: x

 Ttable isNil
		ifTrue: [ self initializeArray.].

  ^ self new initialize: x! !


Gamma subclass: #Erlang
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!Erlang methodsFor: 'initialization' stamp: 'A.T. 8/16/1998 22:20'!
initialize: x n: y
	super initialize:y c:x.
	self name: 'Erlang(', x asString ,',',  y  asString  ,')'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Erlang class
	instanceVariableNames: ''!

!Erlang class methodsFor: 'instance creation' stamp: 'A.T. 8/12/1998 02:00'!
c: x n: y
	^ self new initialize: x n:y
! !


Gamma subclass: #Exponential
	instanceVariableNames: 'lambda '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!Exponential methodsFor: 'initialization' stamp: 'A.T. 9/17/1998 00:19'!
initialize: x
     super initialize.
	lambda _ x.
	self name: 'Exponencial(', x asString ,')'
	! !


!Exponential methodsFor: 'probability functions' stamp: 'A.T. 8/12/1998 02:30'!
density: x
	^ (lambda negated * x) exp * lambda! !

!Exponential methodsFor: 'probability functions' stamp: 'A.T. 8/12/1998 02:22'!
mean
	^ 1 / lambda! !

!Exponential methodsFor: 'probability functions' stamp: 'A.T. 8/14/1998 22:04'!
next
	^ (self random) ln negated / lambda! !

!Exponential methodsFor: 'probability functions' stamp: 'A.T. 8/12/1998 02:23'!
var
	^ 1 / (lambda * lambda)! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Exponential class
	instanceVariableNames: ''!

!Exponential class methodsFor: 'instance creation' stamp: 'A.T. 8/12/1998 02:27'!
parameter: x
	^ self new initialize: x! !


Bernoulli subclass: #Geometric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!Geometric methodsFor: 'accesing' stamp: 'A.T. 8/11/1998 00:03'!
p
 	^ super p! !


!Geometric methodsFor: 'initialization' stamp: 'A.T. 8/16/1998 22:21'!
initialize: aNumber
	 self p: aNumber.
	self name: 'Geometric(', p asString ,')'! !


!Geometric methodsFor: 'probability functions' stamp: 'A.T. 8/14/1998 12:33'!
density: anInteger
	^ self p * (  (1-self p) raisedTo: (anInteger-1) )
! !

!Geometric methodsFor: 'probability functions' stamp: 'A.T. 8/13/1998 03:06'!
distribution: anInteger

	| sum |

	sum _ 0.0.

	1 to: anInteger do: [ :i | sum _ sum + self density:i ].
	^ sum
! !

!Geometric methodsFor: 'probability functions' stamp: 'A.T. 8/11/1998 00:03'!
mean
	^  1 / super mean
! !

!Geometric methodsFor: 'probability functions' stamp: 'A.T. 8/14/1998 22:04'!
next

	| r |
	r _ 1.
	[ super next == 0 ] whileTrue: [ r _ r + 1 ].
	^ r

! !

!Geometric methodsFor: 'probability functions' stamp: 'A.T. 8/11/1998 00:04'!
var
	 ^ ( 1 - super var) / ( super mean * super mean )! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Geometric class
	instanceVariableNames: ''!

!Geometric class methodsFor: 'instance creation' stamp: 'A.T. 8/12/1998 02:08'!
parameter: aProbability
	^ self new initialize: aProbability! !


DiscreteDist subclass: #HiperGeometric
	instanceVariableNames: 'N M n '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!HiperGeometric methodsFor: 'initialization' stamp: 'A.T. 8/10/1998 19:54'!
N: a M: b n: c
	N _ a.
	M _ b.
	n _ c! !


!HiperGeometric methodsFor: 'accesing' stamp: 'A.T. 8/10/1998 19:50'!
M
	^ M! !

!HiperGeometric methodsFor: 'accesing' stamp: 'A.T. 8/10/1998 19:50'!
N
	^ N! !

!HiperGeometric methodsFor: 'accesing' stamp: 'A.T. 8/10/1998 19:51'!
n
	^ n! !


!HiperGeometric methodsFor: 'probability functions' stamp: 'A.T. 8/14/1998 12:37'!
density: aNumber
	 self error: 'not yet implemented'! !

!HiperGeometric methodsFor: 'probability functions' stamp: 'A.T. 8/14/1998 12:37'!
distribution: aNumber
	 ^ self error: 'not yet implemented'! !

!HiperGeometric methodsFor: 'probability functions' stamp: 'A.T. 8/10/1998 19:51'!
mean
	^ n * N / M! !

!HiperGeometric methodsFor: 'probability functions' stamp: 'A.T. 8/16/1998 18:13'!
next
	 ^ self error: 'not yet implemented'! !

!HiperGeometric methodsFor: 'probability functions' stamp: 'A.T. 8/10/1998 19:52'!
var
	^ (N-M) * n * M * ( 1 - M / N ) / ( (N-1) * N )! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HiperGeometric class
	instanceVariableNames: ''!

!HiperGeometric class methodsFor: 'instance creation' stamp: 'A.T. 8/14/1998 12:38'!
N: a M:b n:c
	^ super new initialize N:a M:b n:c! !


DiscreteDist subclass: #Multinomial
	instanceVariableNames: 'probArray '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!Multinomial methodsFor: 'initialization' stamp: 'A.T. 8/13/1998 02:08'!
initialize: aCollection
	probArray _ aCollection
		
	! !


!Multinomial methodsFor: 'probability functions' stamp: 'A.T. 8/21/1998 05:19'!
density: n
	 n < (probArray size)
		ifTrue:  [  ^ probArray at: ( (n+1) asInteger) ].

	^ self error: 'value out of range'

		! !

!Multinomial methodsFor: 'probability functions' stamp: 'A.T. 8/30/1998 02:56'!
distribution: n

      | sum |
      sum _ 0.0.

	 n < probArray size
		ifTrue:  [ 0 to: n do: [ :i |  sum _ sum + (self density:i)  ]. 
                     ^ sum ].
	^ 1.0
! !

!Multinomial methodsFor: 'probability functions' stamp: 'A.T. 8/21/1998 05:20'!
mean
	| sum |
	sum _ 0.0.

	0 to: (probArray size-1) do:
			[ :i | sum _ sum + (i * (self density:i) )  ].
	^ sum! !

!Multinomial methodsFor: 'probability functions' stamp: 'A.T. 8/30/1998 02:53'!
next
 	   | k  aux  |

       aux _ self random.

       k _ 0.

       1 to: probArray size do:
       [ :i |
          ( (aux >= k) and: [ aux < (k + (probArray at: i ) ) ] )
			ifTrue: [ ^ (i - 1) ].

               k _ ( k + ( probArray at: i ) ).
       ].

       ^ probArray size.
! !

!Multinomial methodsFor: 'probability functions' stamp: 'A.T. 8/21/1998 05:23'!
var
	| sum m |
	sum _ 0.0.
     m _ self mean.

	0 to: (probArray size-1) do:
			[ :i | sum _ sum + ( (i-m) raisedTo:2 ) * (self density:i)  ].
	^ sum! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Multinomial class
	instanceVariableNames: ''!

!Multinomial class methodsFor: 'instance creation' stamp: 'A.T. 8/21/1998 04:53'!
new: aCollection
	
	^ self new initialize: aCollection! !


ContinousDist subclass: #Normal
	instanceVariableNames: 'mu sigma '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!Normal methodsFor: 'private' stamp: 'A.T. 9/17/1998 00:18'!
initialize:  m sigma: s
     super initialize.
	mu _ m.
	sigma _ s.
	name _ 'Normal(', mu asString, ',', sigma asString, ')'! !


!Normal methodsFor: 'Probability Functions' stamp: 'A.T. 8/11/1998 00:43'!
density:  x
	| twoPi t |
	twoPi _ 2 * Float pi.
	t _ x - mu / sigma.
	^ (-0.5 * t squared) exp / (sigma * twoPi sqrt)

! !

!Normal methodsFor: 'Probability Functions' stamp: 'A.T. 9/17/1998 01:53'!
distribution: aNumber
    | x |

    aNumber = Infinity   ifTrue: [ ^ 1.0 ].
    aNumber = (Infinity negative) ifTrue: [ ^ 0.0 ].

     aNumber < (self mean) 
		ifTrue: [ ^ 1 - (self distribution: ( 2 * (self mean) - aNumber)) ].

     x _ self mean + ( aNumber * self sigma).

    aNumber = self mean ifTrue: [ ^ 0.5 ].
    

	x > ( (self mean) + (4 * (self sigma)) )
		ifTrue: [ ^ 1 - (  ( x * x / 2 negated ) exp / ( x * ( (2 * (Float pi) ) sqrt ) ) ) ].

	^ ( 1 - ( x asFloat Q ) )! !

!Normal methodsFor: 'Probability Functions' stamp: 'A.T. 8/30/1998 20:57'!
inverseDistribution: delta

    | a b  Zu d t |


 (delta < 0 or: [delta > 1]) ifTrue: [ self error: 'parameter must be between 0 and 1' ].

 delta = 0 ifTrue: [ ^ Infinity negative ].
 delta = 1 ifTrue: [ ^ Infinity ].

 delta = 0.5 ifTrue: [ ^ self mean ].
 delta < 0.5  ifTrue: [ ^ ( (self inverseDistribution: (1-delta) ) negated) ].

 a _(self mean).
 b _ ( self mean + ( 4.0 * self var) ).

 d _ 1.0 - delta.

 Zu _ ( a + ( (b-a) /2 ) asFloat).

 t _ 1.0 - ( self distribution: Zu ).

 [ ( t - d ) abs < 1e-4 ] whileFalse:	
	[
		t > d
			ifTrue:   [ a _ Zu ]
			ifFalse:	 [ b _ Zu ].
		Zu _ ( a + ( (b-a)/2.0)  ) asFloat.
         t _ 1.0 - ( self distribution: Zu ).
    ].

   ^ Zu! !

!Normal methodsFor: 'Probability Functions' stamp: 'A.T. 8/11/1998 00:28'!
mean
	^ mu
! !

!Normal methodsFor: 'Probability Functions' stamp: 'A.T. 8/30/1998 21:38'!
next
	| u v |
	 u _ self random.
	 v _ self random.

	 ^ mu + ( (( 2 negated * ( v ln) ) sqrt)  * ( Float pi * ( 2 - u) ) cos * sigma  )
	
! !

!Normal methodsFor: 'Probability Functions' stamp: 'A.T. 8/25/1998 00:35'!
sigma
	^ sigma
! !

!Normal methodsFor: 'Probability Functions' stamp: 'A.T. 8/11/1998 00:47'!
var
	^ sigma * sigma
! !


!Normal methodsFor: 'accesing' stamp: 'A.T. 8/11/1998 00:40'!
mu
	^ mu! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Normal class
	instanceVariableNames: ''!

!Normal class methodsFor: 'instance creation' stamp: 'A.T. 8/12/1998 02:10'!
mu: m sigma: s
	^ self new initialize: m sigma: s! !

!Normal class methodsFor: 'instance creation' stamp: 'A.T. 8/15/1998 20:51'!
standard
	^ self mu: 0 sigma: 1! !


DiscreteDist subclass: #Poisson
	instanceVariableNames: 'm p '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!Poisson methodsFor: 'initialization' stamp: 'A.T. 8/16/1998 22:23'!
initialize: aNumber
m _ aNumber.
p _ (m negated ) exp.
self name: 'Poisson(', m asString ,')'
 ! !


!Poisson methodsFor: 'Probability Functions' stamp: 'A.T. 8/25/1998 15:05'!
density: aNumber
	^ (m raisedTo: aNumber) * p / (aNumber factorial)! !

!Poisson methodsFor: 'Probability Functions' stamp: 'A.T. 8/25/1998 15:07'!
distribution: aNumber
	
	| sum |

	sum _ 0.0.

	1 to: aNumber do: [ :i | sum _ sum + (self density:i) ].
	^ sum

  
! !

!Poisson methodsFor: 'Probability Functions'!
mean
	^ m
! !

!Poisson methodsFor: 'Probability Functions' stamp: 'A.T. 8/14/1998 22:05'!
next
	
	| q n |

	q _ 1.
	n _ 0.

 	[ q >=  p ] whileTrue:
	[   q _ q * (self random).
         q >= p 
			ifTrue: [ n _ n + 1 ]
			ifFalse: [ ^ n ].
	]
    

 
! !

!Poisson methodsFor: 'Probability Functions'!
var
	^ m
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Poisson class
	instanceVariableNames: ''!

!Poisson class methodsFor: 'instance creation' stamp: 'A.T. 8/12/1998 02:10'!
parameter: aNumber
	^ self new initialize: aNumber! !


ContinousDist subclass: #Student
	instanceVariableNames: 'm y '
	classVariableNames: 'Ttable '
	poolDictionaries: ''
	category: 'Math-Random Variables'!

!Student methodsFor: 'probability functions' stamp: 'A.T. 8/29/1998 21:16'!
density: x
  ^ y * ( 1 / ( ( ( 1 + x*x/m) raisedTo: (m+1) ) sqrt) ) ! !

!Student methodsFor: 'probability functions' stamp: 'A.T. 8/29/1998 22:47'!
distribution: x

m > 30 ifTrue: [ ^self error: 'not yet implemented' ].

x <  (Ttable at:m at:1) ifTrue: [ ^ self error: 'not yet implemented' ].
x < (Ttable at:m at:2) ifTrue: [  ^0.9 ].
x < (Ttable at:m at:3) ifTrue: [  ^0.95 ].
x < (Ttable at:m at:4) ifTrue: [  ^0.975 ].
x < (Ttable at:m at:5) ifTrue: [  ^0.99 ].

^ 0.995.


! !

!Student methodsFor: 'probability functions' stamp: 'A.T. 8/30/1998 17:55'!
inverseDistribution: x
 
 | n z | 

 m > 30

	ifTrue:
     [
          n _ Normal standard.
		z _ (n inverseDistribution: x).
		^ z * ( (m/(m-2) ) sqrt ).
     ]

	ifFalse: 
     [
           x <  0.9   ifTrue: [ ^ self error: 'not yet implemented' ].
           x < 0.951  ifTrue: [  ^ Ttable at: m at: 1 ].
		 x < 0.9751 ifTrue: [  ^ Ttable at: m at: 2 ].
		 x < 0.991  ifTrue: [  ^ Ttable at: m at: 3  ].
          x < 0.996  ifTrue: [  ^ Ttable at: m at: 4  ].
		 ^ Ttable at: m at: 5
     ]	! !

!Student methodsFor: 'probability functions' stamp: 'A.T. 8/29/1998 21:13'!
mean
	^ 0.0! !

!Student methodsFor: 'probability functions' stamp: 'A.T. 8/29/1998 21:13'!
next
	self error: 'not yet implemented'! !

!Student methodsFor: 'probability functions' stamp: 'A.T. 8/29/1998 21:15'!
var    
	^m / (m-2)! !


!Student methodsFor: 'initialization' stamp: 'A.T. 9/17/1998 00:19'!
initialize: aNumber
     super initialize.
  	m _  aNumber.
	y _ ( (m+1)/2 ) gamma / ( ((Float pi) * m) sqrt * ( (m/2) gamma ) ).
	 ! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Student class
	instanceVariableNames: ''!

!Student class methodsFor: 'initialization' stamp: 'A.T. 9/14/1998 02:24'!
initializeArray

	Ttable _ Array2D new.
	Ttable width:30 height:5 type:Array.
     Ttable atAllPut: 0.0.
 
  Ttable at: 1 at: 1 put: 3.08.
  Ttable at: 1 at: 2 put: 6.31.
  Ttable at: 1 at: 3 put: 12.7.
  Ttable at: 1 at: 4 put: 31.8. 
  Ttable at: 1 at: 5 put:  63.7.

  Ttable at: 2 at: 1 put: 1.89.
  Ttable at: 2 at: 2 put: 2.92.
  Ttable at: 2 at: 3 put: 4.30.
  Ttable at: 2 at: 4 put:  6.97.
  Ttable at: 2 at: 5 put: 9.93. 

  Ttable at: 3 at: 1 put: 1.64.
  Ttable at: 3 at: 2 put: 2.35.
  Ttable at: 3 at: 3 put: 3.18.
  Ttable at: 3 at: 4 put:  4.54.
  Ttable at: 3 at: 5 put:  5.84.

  Ttable at: 4 at: 1 put:  1.53.
  Ttable at: 4 at: 2 put:  2.13.
  Ttable at: 4 at: 3 put:  2.78.
  Ttable at: 4 at: 4 put:  3.75.
  Ttable at: 4 at: 5 put:  4.60.

  Ttable at: 5 at: 1 put:  1.48.
  Ttable at: 5 at: 2 put: 2.02.
  Ttable at: 5 at: 3 put: 2.57.
  Ttable at: 5 at: 4 put:  3.37.
  Ttable at: 5 at: 5 put:  4.03.

  Ttable at: 6 at: 1 put:  1.44.
  Ttable at: 6 at: 2 put: 1.94.
  Ttable at: 6 at: 3 put: 2.45.
  Ttable at: 6 at: 4 put:  3.14.
  Ttable at: 6 at: 5 put:  3.71.
 
  Ttable at: 7 at: 1 put: 1.42.
  Ttable at: 7 at: 2 put: 1.90.
  Ttable at: 7 at: 3 put: 2.37.
  Ttable at: 7 at: 4 put:  3.00.
  Ttable at: 7 at: 5 put:  3.50.

  Ttable at: 8 at: 1 put: 1.40.
  Ttable at: 8 at: 2 put: 1.86.
  Ttable at: 8 at: 3 put: 2.31.
  Ttable at: 8 at: 4 put:  2.90.
  Ttable at: 8 at: 5 put:  3.36.

  Ttable at: 9 at: 1 put: 1.38.
  Ttable at: 9 at: 2 put: 1.83.
  Ttable at: 9 at: 3 put: 2.26.
  Ttable at: 9 at: 4 put:  2.82.
  Ttable at: 9 at: 5 put:  3.25. 

  Ttable at: 10  at: 1 put: 1.37.
  Ttable at: 10  at: 2 put: 1.81.
  Ttable at: 10  at: 3 put: 2.23. 
  Ttable at: 10  at: 4 put: 2.76.
  Ttable at: 10  at: 5 put: 3.17.

  Ttable at: 11  at: 1 put: 1.36.
  Ttable at: 11  at: 2 put: 1.80.
  Ttable at: 11  at: 3 put: 2.20.
  Ttable at: 11  at: 4 put: 2.72.
  Ttable at: 11  at: 5 put: 3.11.
 
  Ttable at: 12  at: 1 put: 1.36.
  Ttable at: 12  at: 2 put: 1.78.
  Ttable at: 12  at: 3 put: 2.18.
  Ttable at: 12  at: 4 put: 2.68.
  Ttable at: 12  at: 5 put: 3.06.

  Ttable at: 13  at: 1 put: 1.35.
  Ttable at: 13  at: 2 put: 1.77.
  Ttable at: 13  at: 3 put: 2.16.
  Ttable at: 13  at: 4 put: 2.65.
  Ttable at: 13  at: 5 put: 3.01.

  Ttable at: 14  at: 1 put: 1.35.
  Ttable at: 14  at: 2 put: 1.76.
  Ttable at: 14  at: 3 put: 2.15.
  Ttable at: 14  at: 4 put: 2.62.
  Ttable at: 14  at: 5 put: 2.98.

  Ttable at: 15  at: 1 put:  1.34.
  Ttable at: 15  at: 2 put:  1.75.
  Ttable at: 15  at: 3 put:  2.13.
  Ttable at: 15  at: 4 put:  2.60.
  Ttable at: 15  at: 5 put:  2.95.
  
  Ttable at: 16  at: 1 put:  1.34.
  Ttable at: 16  at: 2 put:  1.75.
  Ttable at: 16  at: 3 put:  2.12.
  Ttable at: 16  at: 4 put:  2.58.
  Ttable at: 16  at: 5 put:  2.92.

  Ttable at: 17  at: 1 put:  1.33.
  Ttable at: 17  at: 2 put:  1.74.
  Ttable at: 17  at: 3 put:  2.11.
  Ttable at: 17  at: 4 put:  2.57.
  Ttable at: 17  at: 5 put:   2.90.


  Ttable at: 18  at: 1 put:  1.33.
  Ttable at: 18  at: 2 put:  1.73. 
  Ttable at: 18  at: 3 put:  2.10.
  Ttable at: 18  at: 4 put:  2.55.
  Ttable at: 18  at: 5 put:  2.88.

  Ttable at: 19  at: 1 put: 1.33. 
  Ttable at: 19  at: 2 put: 1.73.  
  Ttable at: 19  at: 3 put: 2.09. 
  Ttable at: 19  at: 4 put:  2.54.
  Ttable at: 19  at: 5 put: 2.86.
  
  Ttable at: 20  at: 1 put:   1.33.
  Ttable at: 20  at: 2 put:  1.73. 
  Ttable at: 20  at: 3 put:  2.09.
  Ttable at: 20  at: 4 put:  2.53.
  Ttable at: 20  at: 5 put: 2.85.

  Ttable at: 21  at: 1 put:  1.32.  
  Ttable at: 21  at: 2 put:  1.72.
  Ttable at: 21  at: 3 put:  2.07.
  Ttable at: 21  at: 4 put:  2.51. 
  Ttable at: 21  at: 5 put:  2.82.

  Ttable at: 22  at: 1 put:  1.32.  
  Ttable at: 22  at: 2 put:  1.72.
  Ttable at: 22  at: 3 put:  2.07.
  Ttable at: 22  at: 4 put:  2.51. 
  Ttable at: 22  at: 5 put:  2.82.

  Ttable at: 23  at: 1 put:  1.32.  
  Ttable at: 23  at: 2 put:  1.71.
  Ttable at: 23  at: 3 put:  2.06.
  Ttable at: 23  at: 4 put:  2.49. 
  Ttable at: 23  at: 5 put:  2.80.

  Ttable at: 24  at: 1 put:  1.32.  
  Ttable at: 24  at: 2 put:  1.71.
  Ttable at: 24  at: 3 put:  2.06.
  Ttable at: 24  at: 4 put:  2.49. 
  Ttable at: 24  at: 5 put:  2.80.

  Ttable at: 25  at: 1 put:  1.32.  
  Ttable at: 25  at: 2 put:  1.71.
  Ttable at: 25  at: 3 put:  2.06.
  Ttable at: 25  at: 4 put:  2.48. 
  Ttable at: 25  at: 5 put:  2.78.

  Ttable at: 26  at: 1 put:  1.32.  
  Ttable at: 26  at: 2 put:  1.71.
  Ttable at: 26  at: 3 put:  2.06.
  Ttable at: 26  at: 4 put:  2.48. 
  Ttable at: 26  at: 5 put:  2.78.

  Ttable at: 27  at: 1 put:   1.31.
  Ttable at: 27  at: 2 put:  1.70. 
  Ttable at: 27  at: 3 put:   2.05.
  Ttable at: 27  at: 4 put:  2.46.
  Ttable at: 27  at: 5 put:  2.75.

  Ttable at: 28  at: 1 put:   1.31.
  Ttable at: 28  at: 2 put:  1.70. 
  Ttable at: 28 at: 3 put:   2.05.
  Ttable at: 28  at: 4 put:  2.47.
  Ttable at: 28  at: 5 put:  2.76.

  Ttable at: 29  at: 1 put:   1.31.
  Ttable at: 29  at: 2 put:  1.70. 
  Ttable at: 29  at: 3 put:   2.05.
  Ttable at: 29  at: 4 put:  2.46.
  Ttable at: 29  at: 5 put:  2.75.

  Ttable at: 30  at: 1 put:  1.31.
  Ttable at: 30  at: 2 put:  1.70. 
  Ttable at: 30  at: 3 put:  2.05.
  Ttable at: 30  at: 4 put:  2.46.
  Ttable at: 30  at: 5 put:  2.75.! !


!Student class methodsFor: 'instance creation' stamp: 'A.T. 8/30/1998 21:09'!
m: aNumber
     Ttable isNil
		ifTrue: [ self initializeArray.].

	^ self new initialize: aNumber.! !


ContinousDist subclass: #Uniform
	instanceVariableNames: 'a b '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Random Variables'!
!Uniform commentStamp: 'A.T. 9/17/1998 02:23' prior: 0!
Uniform generator. I give numbers between a and b with uniform probability. 
Default values for a and b are: a=0 b=1.!


!Uniform methodsFor: 'accesing' stamp: 'A.T. 8/11/1998 00:17'!
a
	^a! !

!Uniform methodsFor: 'accesing' stamp: 'A.T. 8/11/1998 00:17'!
b
	^b! !


!Uniform methodsFor: 'initialization' stamp: 'A.T. 9/17/1998 00:19'!
initialize: aNumber to: anotherNumber
     super initialize.
    	a _ aNumber.
	b _ anotherNumber.
	self name: 'Uniform(' a asString , ',', b  asString ,')'! !


!Uniform methodsFor: 'probability functions' stamp: 'A.T. 8/21/1998 04:45'!
density: aNumber

 aNumber <= a or: [ aNumber >= b ]
  			ifTrue: [ ^ 0.0  ].

 ^  1 / (b-a)

   
! !

!Uniform methodsFor: 'probability functions' stamp: 'A.T. 8/21/1998 04:46'!
distribution: aNumber

    aNumber >= b  ifTrue: [ ^ 1.0 ].
    aNumber <= a ifTrue:  [ ^ 0.0 ].

   ^ aNumber / (b-a)
! !

!Uniform methodsFor: 'probability functions' stamp: 'A.T. 8/30/1998 02:35'!
inverseDistribution: x
   ( (x >=0)  and: [ x<=1] ) ifTrue: [ ^ a+ ((b-a)*x) ].
	^ self error: 'invalid parameter'

! !

!Uniform methodsFor: 'probability functions' stamp: 'A.T. 8/11/1998 00:18'!
mean
	^ (a + b) / 2! !

!Uniform methodsFor: 'probability functions' stamp: 'A.T. 8/14/1998 22:06'!
next
	^ self random * (b-a) + a! !

!Uniform methodsFor: 'probability functions' stamp: 'A.T. 8/11/1998 00:19'!
var
	^ ( b - a ) raisedTo: 2 / 12! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Uniform class
	instanceVariableNames: ''!

!Uniform class methodsFor: 'instance creation' stamp: 'A.T. 8/12/1998 02:12'!
from: aNumber to: anotherNumber
^ self new initialize: aNumber to: anotherNumber! !
