Object subclass: #Statistic
	instanceVariableNames: 'sample Xm S2 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!Statistic methodsFor: 'basic statistics' stamp: 'A.T. 8/12/1998 13:24'!
histogram: n

	| a b |

     a _ self mean - 5 * self s.
     b _ self mean + 5 * self s.
 
     ^ self histogram: n from:a to: b
  
    
! !

!Statistic methodsFor: 'basic statistics' stamp: 'A.T. 8/16/1998 19:50'!
histogram: n from: a to: b

	| h m result |

     h _ (b-a)/n.
     m _ 0.

     result _ Array new: n withAll:0.
      1 to: sample size do: [ :i | m _ ( ( (sample at:i) - a / h + 1 ) integerPart asInteger). 
                         m>0
						ifTrue: [ m<= result size 
								       ifTrue: [ result at: m put: ( (result at:m)+1) ].
                                      ].                                     
                  ].   
     ^ result! !

!Statistic methodsFor: 'basic statistics' stamp: 'A.T. 8/12/1998 18:14'!
mean

	Xm isNil

		ifTrue: [ Xm _ sample average ].

	^ Xm.
	! !

!Statistic methodsFor: 'basic statistics' stamp: 'A.T. 8/12/1998 13:11'!
s
	^ self s2 sqrt! !

!Statistic methodsFor: 'basic statistics' stamp: 'A.T. 8/12/1998 18:15'!
s2

     | xm sum n1 |

     S2 isNil

		ifTrue:
     	[
			xm _ self mean.	
			sum _ 0.0.
			n1 _ (sample size - 1).
		     1 to: sample size do: [ :i | sum _ sum + ( ( (sample at:i)-xm) * ((sample at:i)-xm) / n1 )  ].
			S2 _ sum
	    ].

    ^ S2! !

!Statistic methodsFor: 'basic statistics' stamp: 'A.T. 8/25/1998 01:09'!
size

	^ sample size
	! !


!Statistic methodsFor: 'initialization' stamp: 'A.T. 8/12/1998 13:07'!
initialize: aSample
	sample _ aSample! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Statistic class
	instanceVariableNames: ''!

!Statistic class methodsFor: 'instance creation' stamp: 'A.T. 8/12/1998 12:53'!
sample: aSample
	^ self new initialize: aSample! !


Statistic subclass: #PointEstimator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!PointEstimator methodsFor: 'initialization' stamp: 'A.T. 8/25/1998 00:13'!
initialize: aSample
	^ super initialize: aSample! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PointEstimator class
	instanceVariableNames: ''!

!PointEstimator class methodsFor: 'instance creation' stamp: 'A.T. 8/25/1998 00:14'!
sample: aSample
	^ self new initialize: aSample! !


PointEstimator subclass: #MeanEstimator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!MeanEstimator methodsFor: 'estimation' stamp: 'A.T. 8/25/1998 12:55'!
confidenceInterval: delta
		self subclassResponsibility! !

!MeanEstimator methodsFor: 'estimation' stamp: 'A.T. 8/25/1998 12:55'!
lowerBound: delta
		self subclassResponsibility! !

!MeanEstimator methodsFor: 'estimation' stamp: 'A.T. 8/25/1998 23:16'!
upperBound: delta
		self subclassResponsibility! !



MeanEstimator subclass: #MeanEstimatorWithVar
	instanceVariableNames: 'sigma2 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!MeanEstimatorWithVar methodsFor: 'accsesing' stamp: 'A.T. 8/25/1998 02:05'!
sigma
	^ sigma2 sqrt! !

!MeanEstimatorWithVar methodsFor: 'accsesing' stamp: 'A.T. 8/25/1998 02:05'!
sigma2
	^ sigma2! !


!MeanEstimatorWithVar methodsFor: 'initialization' stamp: 'A.T. 8/25/1998 00:57'!
initialize: aSample var: aVar
	super initialize: aSample.
	sigma2 _ aVar.

! !


MeanEstimator subclass: #MeanEstimatorWithoutVar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!


MeanEstimatorWithoutVar subclass: #BinomialMeanEstimator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!BinomialMeanEstimator methodsFor: 'estimation' stamp: 'A.T. 8/25/1998 13:37'!
confidenceInterval: delta

 | d  Zu t1 t2 n |

 n _ Normal standard.

 d _ delta + ( ( 1-delta) / 2).

 Zu _ n inverseDistribution: d.

 t1 _ self mean - ( Zu / (2 * (self size sqrt)) ) .
 t2 _ self mean + ( Zu / (2 * (self size sqrt)) ) .

 ^ t1  asString, ' ; ' , t2  asString, '   ( Xm = ', (self mean) asString, '   interval: ',  (t2-t1) asString ,' )'.
 
 ! !


!BinomialMeanEstimator methodsFor: 'initialization' stamp: 'A.T. 8/25/1998 13:32'!
initialize: aSample
	^ super initialize: aSample! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BinomialMeanEstimator class
	instanceVariableNames: ''!

!BinomialMeanEstimator class methodsFor: 'instance creation' stamp: 'A.T. 8/25/1998 13:32'!
sample: aSample
	^ self new initialize: aSample! !


MeanEstimatorWithoutVar subclass: #ExponentialMeanEstimator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!ExponentialMeanEstimator methodsFor: 'estimation' stamp: 'A.T. 8/25/1998 12:54'!
confidenceInterval: delta

 | d  Zu t1 t2 n |

 n _ Normal standard.

 d _ delta + ( ( 1-delta) / 2).

 Zu _ n inverseDistribution: d.

 t1 _ self mean / ( 1 + ( Zu / (self size sqrt) ) ).
 t2 _ self mean / ( 1  - ( Zu / (self size sqrt) ) ).

 ^ t1  asString, ' ; ' , t2  asString, '   ( Xm = ', (self mean) asString, '   interval: ',  (t2-t1) asString ,' )'.
 
 


 

	! !


!ExponentialMeanEstimator methodsFor: 'initialization' stamp: 'A.T. 8/25/1998 03:11'!
initialize: aSample
	^ super initialize: aSample! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ExponentialMeanEstimator class
	instanceVariableNames: ''!

!ExponentialMeanEstimator class methodsFor: 'instance creation' stamp: 'A.T. 8/25/1998 03:27'!
sample: aSample
	^ self new initialize: aSample! !


MeanEstimatorWithoutVar subclass: #MeanEstimatorWithoutVarStudent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!


!MeanEstimatorWithoutVarStudent methodsFor: 'estimation' stamp: 'A.T. 8/30/1998 21:17'!
confidenceInterval: delta
	
 | d  Zu t1 t2 n |

 n _ Student m: ( self size - 1).

 d _ delta + ( ( 1-delta) / 2).

 Zu _ n inverseDistribution: d.

 t1 _ self mean - ( Zu / (2 * (self size sqrt)) ) .
 t2 _ self mean + ( Zu / (2 * (self size sqrt)) ) .

 ^ t1  asString, ' ; ' , t2  asString, '   ( Xm = ', (self mean) asString, '   interval: ',  (t2-t1) asString ,' )'.
 
 ! !


MeanEstimatorWithVar subclass: #NormalWithVarMeanEstimator
	instanceVariableNames: 'z '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!NormalWithVarMeanEstimator methodsFor: 'estimation' stamp: 'A.T. 8/25/1998 03:05'!
confidenceInterval: delta

| a b  Zu d t tmp |

 a _ 0.0.
 b _ 5.0.
 d _ 1.0 - delta / 2.0.

 Zu _ ( a + ( (b-a) /2 ) asFloat).

 t _ 1.0 - ( z distribution: Zu ).

 [ ( t - d ) abs < 1e-8 ] whileFalse:	
	[
		t > d
			ifTrue:   [ a _ Zu ]
			ifFalse:	 [ b _ Zu ].
		Zu _ ( a + ( (b-a)/2.0)  ) asFloat.
         t _ 1.0 - ( z distribution: Zu ).
    ].

   tmp _ Zu * (self sigma) / ( (self size) sqrt ) .
  
  ^  ((self mean) - tmp) asString, ' , ',  ((self mean) + tmp) asString, '   ( Xm= ', (self mean) asString, ' err: ',   tmp  asString ,' )'.



 



      
    


! !


!NormalWithVarMeanEstimator methodsFor: 'initialization' stamp: 'A.T. 8/25/1998 00:57'!
initialize: aSample var: aVar
	super initialize: aSample var: aVar.
	z _ Normal standard
	
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NormalWithVarMeanEstimator class
	instanceVariableNames: ''!

!NormalWithVarMeanEstimator class methodsFor: 'instance creation' stamp: 'A.T. 8/25/1998 01:49'!
sample: aSample var: s
	^ self new initialize: aSample var: s! !


MeanEstimatorWithoutVar subclass: #PoissonMeanEstimator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!PoissonMeanEstimator methodsFor: 'estimation' stamp: 'A.T. 8/30/1998 03:16'!
confidenceInterval: delta

 | d  Zu t1 t2 n  X size  b | 

 n _ Normal standard.

 d _ delta + ( ( 1-delta) / 2).

 Zu _ n inverseDistribution: d.

 X _ self mean.
 size _ self size.

 b _ BisectionRootApproximator function: ( Function evaluator: [ :t |   ( t - Xm ) squared - (Zu * t / size ) ]   ) left: (X-( (self s) * 5) ) right: X.
 t1 _ (b approximationWithError: 1e-6) asFloat.
 b _ BisectionRootApproximator function: ( Function evaluator: [ :t |   ( t - Xm ) squared  - (Zu * t / size ) ]   ) left: X right: (X+( (self s) * 5 ) ).
 t2 _ (b approximationWithError: 1e-6) asFloat.

 ^ t1  asString, ' ; ' , t2  asString, '   ( Xm = ', (self mean) asString, '   interval: ',  (t2-t1) asString ,' )'.
 
 

! !


!PoissonMeanEstimator methodsFor: 'initialization' stamp: 'A.T. 8/25/1998 13:05'!
initialize: aSample
	^ super initialize: aSample! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PoissonMeanEstimator class
	instanceVariableNames: ''!

!PoissonMeanEstimator class methodsFor: 'instance creation' stamp: 'A.T. 8/25/1998 13:06'!
sample: aSample
	^ self new initialize: aSample! !


MeanEstimatorWithVar subclass: #TchebycheffWithVarMeanEstimator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!TchebycheffWithVarMeanEstimator methodsFor: 'initialization' stamp: 'A.T. 8/25/1998 03:03'!
initialize: aSample var: aVar
	super initialize: aSample var: aVar.
	

	! !


!TchebycheffWithVarMeanEstimator methodsFor: 'estimation' stamp: 'A.T. 8/25/1998 03:04'!
confidenceInterval: delta

 | d t  |

 d _ 1.0 - delta.

 t _ self sigma / ( ( (self size) * d ) sqrt ).
  
 ^  ((self mean) - t) asString, ' , ',  ((self mean) + t) asString, '   ( Xm= ', (self mean) asString, ' err: ',   t asString ,' )'.

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

TchebycheffWithVarMeanEstimator class
	instanceVariableNames: ''!

!TchebycheffWithVarMeanEstimator class methodsFor: 'instance creation' stamp: 'A.T. 8/25/1998 03:02'!
sample: aSample var: aVar
	^ self new initialize: aSample var: aVar.! !


PointEstimator subclass: #VarianceEstimator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!


VarianceEstimator subclass: #VarianceEstimatorWithMean
	instanceVariableNames: 'mu varEst '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!VarianceEstimatorWithMean methodsFor: 'estimation' stamp: 'A.T. 8/29/1998 17:37'!
varEst
	  | sum n1 |

     varEst isNil

		ifTrue:
             [
			sum _ 0.0.
			n1 _ sample size.
		    1 to: sample size do: [ :i | sum _ sum + ( ( (sample at:i)-mu) * ((sample at:i)-mu) / n1 )  ].
			varEst _ sum
	    ].

    ^ varEst! !


!VarianceEstimatorWithMean methodsFor: 'initialization' stamp: 'A.T. 8/29/1998 16:42'!
initialize: aSample mean: aMean
	super initialize: aSample.
	mu _ aMean.! !


VarianceEstimatorWithMean subclass: #NormalWithMeanVarianceEstimator
	instanceVariableNames: 'v '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!NormalWithMeanVarianceEstimator methodsFor: 'estimation' stamp: 'A.T. 8/30/1998 00:28'!
confidenceInterval: delta

 |  x1 x2 t1 t2 n chi |

 n _ self size.

 chi _ ChiSquared nu: n.

 x1 _ chi inverseDistribution: ( (1 - delta)/2 ).
 x2 _ chi inverseDistribution: ( delta + ((1-delta)/2) ).

  t2 _ n * ( self varEst ) / x1.
  t1 _ n * ( self varEst ) / x2.

 ^ t1  asString, ' ; ' , t2  asString, '   (Var = ', (self varEst ) asString, '   interval: ',  (t2-t1) asString! !


!NormalWithMeanVarianceEstimator methodsFor: 'initialization' stamp: 'A.T. 8/29/1998 16:40'!
initialize: aSample mean: aMean
	super initialize: aSample mean: aMean! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NormalWithMeanVarianceEstimator class
	instanceVariableNames: ''!

!NormalWithMeanVarianceEstimator class methodsFor: 'instance creation' stamp: 'A.T. 8/29/1998 23:10'!
sample: aSample mean:  aMean
	^ self new initialize: aSample mean: aMean! !


VarianceEstimatorWithMean subclass: #NormalWithoutMeanVarianceEstimator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!

!NormalWithoutMeanVarianceEstimator methodsFor: 'initialization' stamp: 'A.T. 8/30/1998 02:02'!
initialize: aSample
	super initialize: aSample
	! !


!NormalWithoutMeanVarianceEstimator methodsFor: 'estimation' stamp: 'A.T. 8/30/1998 02:14'!
confidenceInterval: delta
| n chi t1 t2 inf sup |

n _ self size.

chi _ ChiSquared nu: (n-1).

t1 _ ( chi inverseDistribution: ( (1-delta)/2)  ).
t2 _ ( chi inverseDistribution: ( ( delta + (1-delta)/2) ) ).

inf _( (n-1) * ( (self s2) / t2 )).
sup _( (n-1) * ( (self s2) / t1 )).

^ inf  asString, ' ; ' , sup  asString, '   (Var = ', (self s2 ) asString, '   interval: ',  (sup-inf) asString, ' )'




! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NormalWithoutMeanVarianceEstimator class
	instanceVariableNames: ''!

!NormalWithoutMeanVarianceEstimator class methodsFor: 'instance creation' stamp: 'A.T. 8/30/1998 02:04'!
sample: aSample
	^ self new initialize: aSample! !


VarianceEstimator subclass: #VarianceEstimatorWithoutMean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Statistics'!
